Draft BSpline: Difference between revisions

From FreeCAD Documentation
(Languages in alphabetic order)
No edit summary
Line 1: Line 1:
{{GuiCommand|Name=Draft BSpline|Workbenches=[[Draft Module|Draft]]|MenuLocation=Draft -> BSpline|Shortcut=B S}}
{{GuiCommand|Name=Draft BSpline|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> BSpline|Shortcut=B S|SeeAlso=[[Draft Wire]]}}


====Description====
==Description==


The BSpline tool creates a [http://en.wikipedia.org/wiki/B-spline B-Spline curve] from several points in the current [[Draft Workingplane|work plane]]. It takes the [[Draft Linestyle|linewidth and color]] previously set on the Tasks tab. The BSpline tool behaves exactly like the [[Draft Wire]] tool.
This tool asks the user for several points and draws a B-Spline passing through them. The newly created wire will have the current color and width.
The points can be picked with the mouse in the 3d view or by entering coordinates with the keyboard.


[[Image:Draft_bspline_example.jpg|400px]]
====Usage====


==How to use==
* Picking a point on an empty area of the 3d view, or on an existing object.

* Pressing {{KEY|CTRL}} will [[Draft_Snap|snap]] your point to available snap locations.
# Press the {{KEY|[[Image:Draft BSpline.png|16px]] [[Draft BSpline]]}} button, or press {{KEY|B}} then {{KEY|S}} keys
* Pressing {{KEY|SHIFT}} will [[Draft_Constrain|constrain]] your new point in relation to the last one.
# Click a first point on the 3D view, or type a [[Draft_Coordinates|coordinate]]
* Enter numbers to [[Draft_Coordinates|manually insert a coordinate]].
# Click additional point on the 3D view, or type a [[Draft_Coordinates|coordinate]]
* Pressing {{KEY|CTRL}}+{{KEY|Z}} or pressing the "Undo" button will undo the last point.
# Press {{KEY|F}} or {{KEY|C}}, or double-click the last point, or click on the first point to finish or close the spline. If the spline is closed, it will also be a face, even if it appears as wireframe.
* Pressing {{KEY|ESC}} will cancel the operation.

* The newly created spline will take the current [[Draft_Linestyle|linestyle]].
==Options==
* Double-clicking the last point, instead of simply clicking, will finish and close the spline.

* Pressing {{KEY|F}} or context menu > draft > Finish or pressing the "Finish" button will also finish the spline, leaving it open.
* Press {{KEY|F}} or the {{KEY|[[Image:Draft FinishLine.png|12px]] '''[[Draft_FinishLine|Finish]]'''}} button to finish the spline, leaving it open
* {{KEY|CTRL}}-Clicking (snapping) on the first point will finish and close the spline
* Press {{KEY|C}} or the {{KEY|[[Image:Draft CloseLine.png|12px]] '''[[Draft_CloseLine|Close]]'''}} button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
* Pressing {{KEY|C}} or context menu > draft > Close or pressing the "Close" button will also finish and close the spline.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* Closing/opening the wire can also be done via its properties.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|ENTER}} between each X, Y and Z component.
* An open spline can have a dimension symbol displayed at its endpoint, so it can be used as a leader.
* Press {{KEY|R}} or click the checkbox to check/uncheck the {{KEY|'''Relative'''}} button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
* Press {{KEY|T}} or click the checkbox to check/uncheck the {{KEY|'''Continue'''}} button. If continue mode is on, the BSpline tool will restart after you finish or close it, allowing you to draw another one without pressing the BSpline button again.
* Press {{KEY|CTRL}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|SHIFT}} while drawing to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|W}} or press the {{KEY|[[Image:Draft Wipe.png|12px]] '''Wipe'''}} button to remove the existing segments and start the spline from the last point.
* Press {{KEY|CTRL}}+{{KEY|Z}} or press the {{KEY|[[Image:Draft UndoLine.png|12px]] '''[[Draft_UndoLine|Undo]]'''}} button to undo the last point.
* Press {{KEY|I}} or the {{KEY|'''Filled'''}} button to have the spline to appear as a face after it has been closed. This simply sets the View->Property of the Wire to "Flat lines" or "Wireframe", so it can easily be changed later.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current BSpline command.

==Properties==

* {{PropertyData|Closed}}: Specifies if the spline is closed or not
* {{PropertyView|End Arrow}}: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line

==Scripting==

The BSpline tool can by used in [[macros]] and from the python console the following way:

import FreeCAD,Draft
p1 = FreeCAD.Vector(0,0,0)
p2 = FreeCAD.Vector(1,1,0)
p3 = FreeCAD.Vector(2,0,0)
myWire = Draft.makeBSpline([p1,p2,p3],closed=True)


{{Languages| {{es|Draft_BSpline/es}} {{fr|Draft_BSpline/fr}} {{it|Draft_BSpline/it}} {{se|Draft_BSpline/se}} }}
{{Languages| {{es|Draft_BSpline/es}} {{fr|Draft_BSpline/fr}} {{it|Draft_BSpline/it}} {{se|Draft_BSpline/se}} }}

Revision as of 19:38, 17 August 2012

Draft BSpline

Menu location
Draft -> BSpline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
-
See also
Draft Wire

Description

The BSpline tool creates a B-Spline curve from several points in the current work plane. It takes the linewidth and color previously set on the Tasks tab. The BSpline tool behaves exactly like the Draft Wire tool.

How to use

  1. Press the Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate
  3. Click additional point on the 3D view, or type a coordinate
  4. Press F or C, or double-click the last point, or click on the first point to finish or close the spline. If the spline is closed, it will also be a face, even if it appears as wireframe.

Options

  • Press F or the Finish button to finish the spline, leaving it open
  • Press C or the Close button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press ENTER between each X, Y and Z component.
  • Press R or click the checkbox to check/uncheck the Relative button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
  • Press T or click the checkbox to check/uncheck the Continue button. If continue mode is on, the BSpline tool will restart after you finish or close it, allowing you to draw another one without pressing the BSpline button again.
  • Press CTRL while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press SHIFT while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press W or press the Wipe button to remove the existing segments and start the spline from the last point.
  • Press CTRL+Z or press the Undo button to undo the last point.
  • Press I or the Filled button to have the spline to appear as a face after it has been closed. This simply sets the View->Property of the Wire to "Flat lines" or "Wireframe", so it can easily be changed later.
  • Press ESC or the Cancel button to abort the current BSpline command.

Properties

  • DataClosed: Specifies if the spline is closed or not
  • ViewEnd Arrow: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line

Scripting

The BSpline tool can by used in macros and from the python console the following way:

import FreeCAD,Draft
p1 = FreeCAD.Vector(0,0,0)
p2 = FreeCAD.Vector(1,1,0)
p3 = FreeCAD.Vector(2,0,0)
myWire = Draft.makeBSpline([p1,p2,p3],closed=True)
Available translations of this page: Template:Se